//+------------------------------------------------------------------+
//|                                                       SL_DEV.mq4 |
//|                               Copyright  2011, Vladimir Hlystov |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2011, Vladimir Hlystov"
#property link      "cmillion@narod.ru"
 
#property indicator_chart_window
#property  indicator_buffers 4
#property  indicator_color1  Blue
#property  indicator_color2  Red
#property  indicator_color3  Red
#property  indicator_color4  Blue
 
//+------------------------------------------------------------------+
extern string TimeFrame      = "Current time frame";
extern int    Period_DEV     = 14;
extern int    Price_DEV      = PRICE_CLOSE; 
extern double Multiplier_DEV = 1;
extern bool   Interpolate    = true;
//+------------------------------------------------------------------+
double SLSell[],SLBay[];
double     BufferBuy[];
double     BufferSell[];

string indicatorFileName;
bool   returnBars;
bool   calculateValue;
int    timeFrame = 0;

//+------------------------------------------------------------------+
int init()
  {
//---- drawing settings
   SetIndexStyle(0,DRAW_LINE);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexStyle(2,DRAW_ARROW);
   SetIndexArrow(2,234);
   SetIndexStyle(3,DRAW_ARROW);
   SetIndexArrow(3,233);
//---- indicator buffers mapping
   SetIndexBuffer(0,SLSell);
   SetIndexBuffer(1,SLBay);
   SetIndexBuffer(2,BufferBuy);
   SetIndexBuffer(3,BufferSell);
//---- name for DataWindow and indicator subwindow label
   SetIndexLabel(0,"SL Sell ");
   SetIndexLabel(1,"SL Bay ");
//---- initialization done
         indicatorFileName = WindowExpertName();
         returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
         calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
         timeFrame         = stringToTimeFrame(TimeFrame);
   return(0);
  }
//+------------------------------------------------------------------+
int deinit()
  {
   return(0);
  }
//+------------------------------------------------------------------+
int start()
  {
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);
           if (returnBars) { SLSell[0] = limit; return(0); }
   
   if (calculateValue || timeFrame==Period())   
   {
      for(int i=limit; i>=0; i--) 
      {
         double DEV = Multiplier_DEV*iEDev(iMA(NULL,0,1,0,MODE_SMA,Price_DEV,i),Period_DEV,i);
         if (NormalizeDouble(High[i] + DEV,Digits)<=SLBay[i+1] || SLBay[i+1]==EMPTY_VALUE) SLBay[i]  = NormalizeDouble(High[i] + DEV,Digits);
         //else SLBay[i]=SLBay[i+1];
         if (High[i]>=SLBay[i]) SLBay[i]=EMPTY_VALUE;
         if (SLBay[i+2]==EMPTY_VALUE && SLBay[i+1]>=SLBay[i] && SLBay[i]!=EMPTY_VALUE) BufferBuy[i+1]=SLBay[i+1];
      
         if (NormalizeDouble(Low[i]  - DEV,Digits)>=SLSell[i+1] || SLSell[i+1]==EMPTY_VALUE) SLSell[i] = NormalizeDouble(Low[i]  - DEV,Digits);
         //else SLSell[i]=SLSell[i+1];
         if (Low[i]<=SLSell[i]) SLSell[i]=EMPTY_VALUE;
         if (SLSell[i+2]==EMPTY_VALUE && SLSell[i+1]<=SLSell[i] && SLSell[i]!=EMPTY_VALUE) BufferSell[i+1]=SLSell[i+1];
      }
      return(0);
   }
   
   //
   //
   //
   //
   //

   for(i = limit; i >=0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
      int x = iBarShift(NULL,timeFrame,Time[i+1]);
         SLSell[i]     = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Period_DEV,Price_DEV,Multiplier_DEV,0,y);
         SLBay[i]      = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Period_DEV,Price_DEV,Multiplier_DEV,1,y);
         BufferBuy[i]  = EMPTY_VALUE;
         BufferSell[i] = EMPTY_VALUE;
         if (x!=y)
         {
            BufferBuy[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Period_DEV,Price_DEV,Multiplier_DEV,2,y);
            BufferSell[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Period_DEV,Price_DEV,Multiplier_DEV,3,y);
         }
         if (!Interpolate || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;
         
         interpolate(SLSell,iTime(NULL,timeFrame,y),i);
         interpolate(SLBay ,iTime(NULL,timeFrame,y),i);
  }
  return(0);
}  
//+------------------------------------------------------------------+

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double edevWork[][2];
double iEDev(double price,double period, int i)
{
   if (ArrayRange(edevWork,0)!=Bars) ArrayResize(edevWork,Bars);
   
   int    r     = Bars-i-1;
   double alpha = 2.0/(1.0+period);
      
      edevWork[r][0] = edevWork[r-1][0]+alpha*(price      -edevWork[r-1][0]);
      edevWork[r][1] = edevWork[r-1][1]+alpha*(price*price-edevWork[r-1][1]);
         
   return(MathSqrt(period*(edevWork[r][1]-edevWork[r][0]*edevWork[r][0])/(period-1.0)));
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

void interpolate(double& buffer[], datetime time, int i)
{
   for (int n = 1; (i+n) < Bars && Time[i+n] >= time; n++) continue;
   
   //
   //
   //
   //
   //
   
   if (buffer[i] == EMPTY_VALUE || buffer[i+n] == EMPTY_VALUE) n=-1;
               double increment = (buffer[i+n] - buffer[i])/ n;
   for (int k = 1; k < n; k++)     buffer[i+k] = buffer[i] + k*increment;
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}